(function(){
var umylist = {
	config:{
		/* fetchするボタンを表示するかどうか */
		fetch:true,//false or true
		/* fetchの状態確認する時間 */
		setIntervalTime:1000,//interval
		/* Unlimited MyList API の結果画面を表示するかどうか */
		resultModal:true, //false or true
		/* ページ表示時にとりあえずマイリストと公式マイリストのデータをよみこむかどうか */
		autoLoadOfficialMyList:false,// false or true
		/* 1カラム表示か2カラム表示にするか */
		column:2,// 1 or 2
		/* デフォルト表示をブロックにするか、list(Table)表示にするかどうか */
		view:'block'//'block' or 'list'
	},
	/* 以下はデータ保存用 */
	data:{'dbid':'','datatype':'','dataid':'','datathreadid':'','dataname':'','mylisttype':'','mylistid':'','mylistname':'','mylisttoid':''},
	timerStart:false,
	timer:undefined,
	globalCacheMovieData:{},
	globalNicoCacheData:{},
	globalNicoCacheIdData:[],
	globalDataUMy:{},
	globalDataUFav:{},
	globalDataDef:undefined,
	globalDataMy:{},
	globalDataList:undefined,
	HashkeySort:function(hash,sort){var sortFunc=sort||"sort";/*reverse*/var keys=[];var newHash={};for(var k in hash){keys.push(k);}keys[sortFunc]();var length=keys.length;for(var i=0;i<length;i++){newHash[keys[i]] = hash[keys[i]];}return newHash;
	},createMovieCheck:function(obj){
		var str = '';
		if(umylist.config.view === 'list'){
			str += '<table class="table table-bordered table-hover table-striped utable">';
			str += '<thead>';
			str += '<tr class="utr">';
			str += '<td class="span2">動画番号</td><td class="span3">B!</td><td>タイトル</td>';
			str += '<tr>';
			str += '</thead>';
			str += '<tbody>';
			str += obj.join('');
			str += '</tbody>';
			str += '</table>';
		}else if(umylist.config.view === 'block'){
			str += obj.join('');
		}else{
			str = '';
		}
		return str;
	},createMovieItemCheck:function(obj){
		if(umylist.config.view === 'list'){
			return umylist.createMovieItemList(obj);
		}else{
			return umylist.createMovieItemBlock(obj,true,true);
		}
	},createMovieItemList:function(obj){
		var str = '';
		var strcache = '';
		var cacheFlag = '';
		if(obj.cache === 'cache'){
			cacheFlag = 'cache';
		}else if(obj.cache === 'economy'){
			cacheFlag = 'economy';
		}else if(obj.cache === undefined){
			var caches = $.grep(umylist.globalNicoCacheIdData, function(cache){
				if (cache.indexOf(obj.id) > -1 || cache.indexOf(obj.id+'low') > -1) return true; else return false;
			});
			if(caches.length > 0){
				$.each(caches, function(key,value) {
					if(value.indexOf('low') === -1){
						cacheFlag = 'cache';
					}else{
						cacheFlag = 'economy';
					}
				});
			}
		}else{
		}
		if(cacheFlag === 'cache'){
			strcache = 'class="cache"';
		}else if(cacheFlag === 'economy'){
			strcache = 'class="cacheconomy"';
		}
		if(obj.deleted !== '0'){
			//str += '<div class="imgdeleted"></div>';
		}
		str += '<tr class="utr" data-db-id="'+obj.db_id+'" data-id="'+obj.id+'" data-thread-id="'+obj.thread_id+'">';
		str += '<td>'+obj.id+'</td>';
		str += '<td class="openModalButtons">';
		var bstr = '';
		if(umylist.data.mylisttype === 'u'){
			bstr += '<button href="#buttonModal" class="btn btn-small btn-primary ubtn" type="button" data-toggle="modal" data-db-id="'+obj.db_id+'" data-id="'+obj.id+'" data-thread-id="'+obj.thread_id+'" data-type="itemdel">削</button>';
			bstr += '<button href="#buttonModal" class="btn btn-small btn-primary ubtn" type="button" data-toggle="modal" data-db-id="'+obj.db_id+'" data-id="'+obj.id+'" data-thread-id="'+obj.thread_id+'" data-type="itemcopy">複</button>';
			bstr += '<button href="#buttonModal" class="btn btn-small btn-primary ubtn" type="button" data-toggle="modal" data-db-id="'+obj.db_id+'" data-id="'+obj.id+'" data-thread-id="'+obj.thread_id+'" data-type="itemmove">移</button>';
		}else if(umylist.data.mylisttype === 'f' || umylist.data.mylisttype === 'n'){
			bstr += '<button href="#buttonModal" class="btn btn-small btn-primary ubtn" type="button" data-toggle="modal" data-db-id="'+obj.db_id+'" data-id="'+obj.id+'" data-thread-id="'+obj.thread_id+'" data-type="itemregister">登録</button>';
		}
		if(umylist.config.fetch && cacheFlag !== 'cache'){
			bstr += '<button class="btn btn-small btn-primary ubtn" type="button" data-id="'+obj.id+'" data-type="itemfetch">fetch</button>';
		}
		if(cacheFlag !== ''){
			//bstr += '<button class="btn btn-small btn-primary ubtn" type="button" data-id="'+obj.id+'" data-type="itemcacherm">rm</button>';
		}
		if(bstr !== ''){
			str += bstr;
		}
		str += '</td>';
		str += '<td><a href="http://www.nicovideo.jp/watch/'+obj.id+'" '+strcache+'>'+obj.title+'</a></td>';
		str += '</tr>';
		return str;
	},createMovieItemBlock:function(obj,bflag,dflag){
		var str = '';
		if(obj === undefined){
			str += '<div class="movie well">';
			str += "Error!";
			str += '</div>';
			return str;
		}
		str += '<div class="movie well" data-db-id="'+obj.db_id+'" data-id="'+obj.id+'" data-thread-id="'+obj.thread_id+'">';
		str += '<div class="info">';
		str += '<div class="thumbdata">';
		str += '<div class="thumb">';
		str += '<img class="thumbImg" src="'+obj.thumb+'">';
		str += '<div class="time">'+obj.sec+'</div>';
		var strcache = '';
		var cacheFlag = '';
		if(obj.cache === 'cache'){
			cacheFlag = 'cache';
		}else if(obj.cache === 'economy'){
			cacheFlag = 'economy';
		}else if(obj.cache === undefined){
			var caches = $.grep(umylist.globalNicoCacheIdData, function(cache){
				if (cache.indexOf(obj.id) > -1 || cache.indexOf(obj.id+'low') > -1) return true; else return false;
			});
			if(caches.length > 0){
				$.each(caches, function(key,value) {
					if(value.indexOf('low') === -1){
						cacheFlag = 'cache';
					}else{
						cacheFlag = 'economy';
					}
				});
			}
		}else{
		}
		if(cacheFlag === 'cache'){
			str += '<div class="cacheicon imgcache"></div>';
			strcache = ' class="cache"';
		}else if(cacheFlag === 'economy'){
			str += '<div class="cacheicon imgcacheeconomy"></div>';
			strcache = ' class="cacheconomy"';
		}
		if(obj.deleted !== '0'){
			str += '<div class="imgdeleted"></div>';
		}
		str += '</div>';
		str += '</div>';
		str += '<div class="moviedata">';
		str += '<div class="movieinfo">';
		str += '<span class="first_retrieve hide">'+obj.first_retrieve+'</span>';
		str += '<span class="date">投稿日:'+obj.date+'</span>';
		str += '<span class="view">再生数:'+obj.view+'</span>';
		str += '<span class="res">コメント:'+obj.num_res+'</span>';
		str += '<span class="mylist">マイリスト:'+obj.mylist_cnt+'</span>';
		if(obj.community_id !== undefined && obj.community_id !== ''){
			str += '<span class="community_id"><a href="http://com.nicovideo.jp/community/co'+obj.community_id+'">co'+obj.community_id+'</a></span>';
		}
		if(obj.channel_id !== undefined && obj.channel_id !== ''){
			str += '<span class="channel_id"><a href="http://ch.nicovideo.jp/channel/ch'+obj.channel_id+'">ch'+obj.channel_id+'</a></span>';
		}
		str += '</div>';
		str += '<div class="title">';
		str += '<a href="http://www.nicovideo.jp/watch/'+obj.id+'"'+strcache+'>'+obj.title+'</a>';
		str += '</div>';
		str += '<div class="tags">';
		if(dflag === undefined || dflag === true){
			$.each(obj.tags, function(key,value) {
				str += '<a class="tag" href="http://www.nicovideo.jp/tag/'+value.text+'">'+(value.lock?'['+value.text+']':value.text)+'</a>';
			});
		}
		str += '</div>';
		str += '</div>';
		str += '</div>';
		str += '<div class="desc">';
		if(dflag === undefined || dflag === true){
			if(obj.comment !== ''){
				str += '<p>'+obj.comment+'</p>';
			}
			str += '<p>'+obj.desc+'</p>';
		}
		str += '</div>';
		var bstr = '';
		if(umylist.data.mylisttype === 'u'){
			bstr += '<button href="#buttonModal" class="btn btn-small btn-primary ubtn" type="button" data-toggle="modal" data-db-id="'+obj.db_id+'" data-id="'+obj.id+'" data-thread-id="'+obj.thread_id+'" data-type="itemdel">削除</button>';
			bstr += '<button href="#buttonModal" class="btn btn-small btn-primary ubtn" type="button" data-toggle="modal" data-db-id="'+obj.db_id+'" data-id="'+obj.id+'" data-thread-id="'+obj.thread_id+'" data-type="itemcopy">複製</button>';
			bstr += '<button href="#buttonModal" class="btn btn-small btn-primary ubtn" type="button" data-toggle="modal" data-db-id="'+obj.db_id+'" data-id="'+obj.id+'" data-thread-id="'+obj.thread_id+'" data-type="itemmove">移動</button>';
		}else{// if(umylist.data.mylisttype === 'f' || ){
			bstr += '<button href="#buttonModal" class="btn btn-small btn-primary ubtn" type="button" data-toggle="modal" data-db-id="'+obj.db_id+'" data-id="'+obj.id+'" data-thread-id="'+obj.thread_id+'" data-type="itemregister">登録</button>';
		}
		if(umylist.config.fetch && cacheFlag !== 'cache'){
			bstr += '<button class="btn btn-small btn-primary ubtn" type="button" data-id="'+obj.id+'" data-type="itemfetch">fetch</button>';
		}
		if(cacheFlag !== ''){
			//bstr += '<button class="btn btn-small btn-primary ubtn" type="button" data-id="'+obj.id+'" data-type="itemcacherm">rm</button>';
		}
		if(bstr !== '' && (bflag === undefined || bflag === true)){
			str += '<div class="buttons openModalButtons">';
			str += bstr;
			str += '</div>';
		}
		str += '</div>';
		return str;
	},createAllUIButton:function(def,type){
		if(type === 'd' || type === 'm' ||  type === 'n'){
			$('#uibutton').hide();
			return;
		}
		var str = '<div id="itemButtons" class="well form-inline uform openModalButtons">';
		str += '<button href="#buttonModal" class="btn btn btn-primary ubtn" type="button" data-toggle="modal" data-id="" data-type="alldel_'+type+'">削除</button>';
		str += '<input type="text" class="uinput span4" placeholder="'+((def===undefined || def==='')?'newname':def)+'">';
		str += '<button href="#buttonModal" class="btn btn btn-primary ubtn" type="button" data-toggle="modal" data-id="" data-type="allrename_'+type+'">変更</button>';
		if(umylist.data.mylisttype === 'u'){
			str += '<button href="#buttonModal" class="btn btn btn-primary ubtn" type="button" data-toggle="modal" data-id="" data-type="allcreate_'+type+'">作成</button>';
		}
		str += '<button href="#buttonModal" class="btn btn btn-primary ubtn" type="button" data-toggle="modal" data-id="" data-type="allappend_'+type+'">追加</button>';
//		str += '<button id="buttonSelect" href="#" class="btn btn btn-primary ubtn" type="button" data-toggle="modal" data-id="" data-type="allselect">選択</button>';
		str += '<button id="buttonSort" href="#" class="btn btn btn-primary ubtn" type="button">ソート</button>';
		str += '</div>';
		//
		str += '<div id="itemSort" class="well form-inline uform openModalButtons hide">';
		str += '<select class="uselect">';
		str += '<option value="id_revers">ID昇順</option>';
		str += '<option value="id_sort">ID降順</option>';
		str += '<option value="title_revers">タイトル昇順</option>';
		str += '<option value="title_sort">タイトル降順</option>';
		str += '<option value="date_revers">投稿日時が新しい順</option>';
		str += '<option value="date_sort">投稿日時が古い順</option>';
		str += '<option value="view_revers">再生数が多い順</option>';
		str += '<option value="view_sort">再生数が少ない順</option>';
		str += '<option value="res_revers">コメント数が多い順</option>';
		str += '<option value="res_sort">コメント数が少ない順</option>';
		str += '<option value="mylist_revers">マイリスト数が多い順</option>';
		str += '<option value="mylist_sort">マイリスト数が少ない順</option>';
		str += '<option value="time_revers">再生時間が長い順</option>';
		str += '<option value="time_sort">再生時間が短い順</option>';
		str += '</select>';
		str += '<button id="buttonSortGo" href="#" class="btn btn btn-primary ubtn" type="button">ソート</button>';
		str += '</div>';
		//
		str += '<div id="itemAllSelect" class="well form-inline uform openModalButtons hide">';
		str += '<button href="#" class="btn btn btn-primary ubtn" type="button" data-toggle="modal" data-id="" data-type="allallselect">全選択</button>';
		if(umylist.data.mylisttype === 'u'){
			str += '<button href="#buttonModal" class="btn btn btn-primary ubtn" type="button" data-toggle="modal" data-id="" data-type="allselectdel_'+type+'">選択削除</button>';
			str += '<button href="#buttonModal" class="btn btn btn-primary ubtn" type="button" data-toggle="modal" data-id="" data-type="allselectcopy_'+type+'">選択複製</button>';
			str += '<button href="#buttonModal" class="btn btn btn-primary ubtn" type="button" data-toggle="modal" data-id="" data-type="allselectmove_'+type+'">選択移動</button>';
		}
		if(umylist.data.mylisttype === 'f' || umylist.data.mylisttype === 'n'){
			str += '<button href="#buttonModal" class="btn btn btn-primary ubtn" type="button" data-toggle="modal" data-id="" data-type="allselectregister_'+type+'">選択登録</button>';
		}
		str += '</div>';
		$('#uibutton').html(str);
		$('#uibutton').show();
	},toggleOptionCheck:function(op){
		if(op === 'all'){
			umylist.toggleOptionAll();
		}else if(op === 'imgSize'){
			umylist.toggleOptionImg();
		}else if(op === 'view'){
			if(umylist.config.view === 'list'){
				umylist.config.view = 'block';
			}else{
				umylist.config.view = 'list';
			}
		}else{
			umylist.toggleOption(op);
		}
	},toggleOption:function(name){
		$(name).each(function() {
			$(this).animate({height:'toggle'},500);
		});
	},toggleOptionImg:function(){
		$('.thumb').each(function() {
			var cthis = $(this);
			if(!cthis.hasClass('smallImg')){
				cthis.animate({width:'65px', height: '50px'},{duration:500,complete:function(){
					cthis.addClass('smallImg');
				}});
			}else{
				cthis.animate({width:'130px', height: '100px'},{duration:500,complete:function(){
					cthis.removeClass('smallImg');
				}});
			}
			cthis.find('.time').toggleClass('hide');
			var ci = cthis.find('.cacheicon');
			if(ci.hasClass('imgcache') || ci.hasClass('imgcache_mini')){
				ci.toggleClass('imgcache');
				ci.toggleClass('imgcache_mini');
			}else if(ci.hasClass('zimgcacheconomy') || ci.hasClass('imgcacheconomy_mini')){
				ci.toggleClass('imgcacheconomy');
				ci.toggleClass('imgcacheconomy_mini');
			}
		});
	},toggleOptionAll:function(){
		umylist.toggleOption('.desc');
		umylist.toggleOption('.tags');
		umylist.toggleOption('.buttons');
		umylist.toggleOptionImg();
	},unixtimeToString:function(unix){
		var d = new Date(unix * 1000);
		var month = d.getMonth() + 1;month = (month < 10) ? '0' + month : month;
		var day = (d.getDate() < 10) ? '0' + d.getDate() : d.getDate();
		var hour = (d.getHours() < 10) ? '0' + d.getHours() : d.getHours();
		var min = (d.getMinutes() < 10) ? '0' + d.getMinutes() : d.getMinutes();
		var sec = (d.getSeconds() < 10) ? '0' + d.getSeconds() : d.getSeconds();
		return d.getFullYear() + '/' + month + '/' + day + ' ' + hour + ':' + min + ':' + sec;
	},dateToUnixtime:function(date){
		return Date.parse(date) / 1000;
	},checkId:function (id,dbid){
		var res = undefined;
		if(typeof id === 'string'){
			res = umylist.globalCacheMovieData[id];
			if(res === undefined){
				umylist.setGlobalThumbinfo(id);
			}
			res = umylist.globalCacheMovieData[id];
		}else{
			$.each(id, function(key,value) {
				res = umylist.globalCacheMovieData[value];
				if(res !== undefined){
					return false;
				}
			});
			//ないなら取得
			if(res === undefined){
				$.each(id, function(key,value) {
					//取得とcacheのIDが違う場合があるので一応チェック
					res = umylist.globalCacheMovieData[value];
					if(res !== undefined){
						return false;
					}
					umylist.setGlobalThumbinfo(value);
					res = umylist.globalCacheMovieData[value];
					if(res !== undefined){
						return false;
					}
				});
			}
		}
		if(res !== undefined){
			res['db_id'] = dbid;
		}
		return res;
	},getAjax:function(url,data,type,dataType,async,error,success,complete){
		return $.ajax({
			url:url,
			type:type,
			data:data,
			dataType:dataType,
			cache:true,
			async:async,
			error:error,
			success:success,
			complete:complete
		});
	},setGlobalThumbinfo:function(id){
		return umylist.globalCacheMovieData[id] ||
		umylist.getAjax('/api/getthumbinfo/'+id,null,'get','xml',true,function(){},function(response){
			var cxml = $(response);
			if(cxml.find('code').text() === 'NOT_FOUND')return;
			var tm = cxml.find('first_retrieve').text().match(/^20(\d{2})-(\d{2})-(\d{2})T(.{8})/);
			var mid = cxml.find('video_id').text();
			umylist.globalCacheMovieData[mid] = 
			{
				'title':cxml.find('title').text(),
				'id':cxml.find('video_id').text(),
				'cache':undefined,
				'deleted':'0',
				'tags':[],
				'desc':cxml.find('description').text(),
				'sec':cxml.find('length').text(),
				'comment':'',
				'thumb':cxml.find('thumbnail_url').text(),
				'first_retrieve':umylist.dateToUnixtime('20'+tm[1]+'/'+tm[2]+'/'+tm[3]+' '+tm[4]),
				'date':'20'+tm[1]+'/'+tm[2]+'/'+tm[3]+' '+tm[4],
				'view':cxml.find('view_counter').text(),
				'mylist_cnt':cxml.find('mylist_counter').text(),
				'thread_id':'',
				'num_res':cxml.find('comment_num').text(),
				'community_id':'',
				'channel_id':'',
			};
			cxml.find('tags[domain=jp]').each(function(){
				$(this).find('tag').each(function(){
					umylist.globalCacheMovieData[mid]['tags'].push({'lock':$(this).attr('lock') == '1'?true:false,'text':$(this).text()});
				});
			});
		});
	},setGlobalDefList:function(){
		return umylist.globalDataDef ||
		umylist.getAjax('/api/deflist/list',null,'get','json',true,function(){},function(response){
			umylist.globalDataDef = {'items':[]};
			$.each(response.mylistitem, function(key,value) {
				var mid = value.item_data.watch_id;
				var lsec = value.item_data.length_seconds;
				var sec = 
					('0' + parseInt(lsec/3600)).slice(-2)+':'+
					('0' + parseInt(lsec%3600/60)).slice(-2)+':'+
					('0' + parseInt(lsec%60)).slice(-2);
				umylist.globalCacheMovieData[mid] = 
				{//
					'title':value.item_data.title,
					'id':value.item_data.video_id,
					'cache':undefined,
					'deleted':'0',
					'tags':[],
					'desc':'',
					'sec':sec,
					'comment':value.description,
					'thumb':value.item_data.thumbnail_url,
					'first_retrieve':value.item_data.first_retrieve,
					'date':umylist.unixtimeToString(value.item_data.first_retrieve),
					'view':value.item_data.view_counter,
					'mylist_cnt':value.item_data.mylist_counter,
					//'thread_id':value.item_data.watch_id,
					'thread_id':'',
					'num_res':value.item_data.num_res,
					'community_id':'',
					'channel_id':'',
				};
				umylist.globalDataDef['items'].push(mid);
			});
		},function(){});
	},setGlobalMyListList:function(){
		return umylist.globalDataList ||
		umylist.getAjax('/api/mylistgroup/list',null,'get','json',true,function(){},function(response){
			umylist.globalDataList = {};
			$.each(response, function(key,value) {
				if(typeof value == 'object'){
					$.each(value, function(key,value) {
						umylist.globalDataList[value.id] = {
							'items':[],
							'id':value.id,
							'title':value.name,
							'description':value.description,
							'user_id':value.user_id,
							'count':0
						};
					});
				}
			});
		},function(){});
	},setGlobalMyList1:function(mylistid){
		return umylist.globalDataMy[mylistid] ||
		umylist.getAjax('/pr_Redirect_flapi.nicovideo.jp/api/getplaylist/mylist/'+mylistid
		,null,'get','json',true,function(){},function(response){
			if(response.status === 'ng'/* || json.status_code === '404'*/){
				umylist.globalDataMy[mylistid] = {'items':[],'title':'','id':mylistid,'description':'','user_id':'','count':0};
				return;
			}
			umylist.globalDataMy[mylistid] = {
				'items':[],
				'title':response.playlist.name,
				'description':response.playlist.description,
				'user_id':response.playlist.user_id,
				'count':response.playlist.count
			};
			$.each(response.items, function(key,value) {
				var mid = value.watch_id;
				var lsec = value.length_seconds;
				var sec = 
					('0' + parseInt(lsec/3600)).slice(-2)+':'+
					('0' + parseInt(lsec%3600/60)).slice(-2)+':'+
					('0' + parseInt(lsec%60)).slice(-2);
				umylist.globalCacheMovieData[mid] = 
				{
					'title':value.title,
					'id':value.video_id,
					'cache':undefined,
					'deleted':'0',
					'tags':[],
					'desc':value.description,
					'sec':sec,
					'comment':value.mylist_comment,
					'thumb':value.thumbnail_url,
					'first_retrieve':value.first_retrieve,
					'date':umylist.unixtimeToString(value.first_retrieve),
					'view':value.view_counter,
					'mylist_cnt':value.mylist_counter,
					'thread_id':value.thread_id,
					'num_res':value.num_res,
					'community_id':'',
					'channel_id':'',
				};
				umylist.globalDataMy[mylistid]['items'].push({'id':mid});
			});
		},function(){});
	},setGlobalMyList2:function(mylistid){
	},setGlobalUnlimited:function(movies,async){
		return $.ajax({
			url:'/pr_Redirect_i.nicovideo.jp/v3/video.array',
			type:'get',
			data:{'v': movies},
			dataType:'xml',
			cache:true,
			async:async,
			error:function(e){},
			success:function(xml){
				$(xml).find('video_info').each(function(){
					var cthis = $(this);
					var tm = cthis.find('first_retrieve').text().match(/^20(\d{2})-(\d{2})-(\d{2})T(.{8})/);
					var mid = cthis.find('video > id').text();
					var lsec = cthis.find('length_in_seconds').text() - 0;
					var sec = 
						('0' + parseInt(lsec/3600)).slice(-2)+':'+
						('0' + parseInt(lsec%3600/60)).slice(-2)+':'+
						('0' + parseInt(lsec%60)).slice(-2);
					umylist.globalCacheMovieData[mid] = 
					{
						'title':cthis.find('video > title').text(),
						'id':cthis.find('video > id').text(),
						'cache':undefined,//cthis.find('cache').text()
						'deleted':cthis.find('deleted').text(),
						'tags':[],
						'desc':cthis.find('description').text(),
						'sec':sec,
						'comment':'',
						'thumb':cthis.find('thumbnail_url').text(),
						'first_retrieve':umylist.dateToUnixtime('20'+tm[1]+'/'+tm[2]+'/'+tm[3]+' '+tm[4]),
						'date':'20'+tm[1]+'/'+tm[2]+'/'+tm[3]+' '+tm[4],
						'view':cthis.find('view_counter').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
						'mylist_cnt':cthis.find('mylist_counter').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
						'thread_id':cthis.find('thread > id').text(),
						'num_res':cthis.find('num_res').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
						'community_id':cthis.find('community_id').text(),
						'channel_id':cthis.find('channel_id').text(),
					};
					cthis.find('tag_info').each(function(){
						var cthis = $(this);
						if(cthis.find('area').text()=='jp'){
							umylist.globalCacheMovieData[mid]['tags'].push({'lock':false,'text':$(this).find('tag').text()});
						}
					});
				});
			}
		});
	},getNicoCacheFlvList:function(){
		return umylist.getAjax('/cache/flvlist',null,'get','text',true,function(){},function(response){umylist.globalNicoCacheIdData = response.match(/([a-z]{2}\d+(low)?)/ig);},function(){});
	},getNicoCacheTempList:function(){
		return umylist.getAjax('/cache/templist.json',null,'get','json',true,function(){},function(response){
			arrays = [];
			$.each(response, function(key,value) {
				arrays.push({'id':key,'title':value[0]});
			});
			if(arrays.length > 0){
				umylist.globalNicoCacheData['#temp'] = arrays;
			}
		},function(){});
	},getNicoCacheList:function(){
		return umylist.getAjax('/cache/cachelist.json',null,'get','json',true,function(){},function(response){
			var hash = {};
			var folderName = '';
			$.each(response, function(key,value) {
				umylist.globalNicoCacheIdData.push(key);
				folderName = value[1];
				if(folderName === ''){folderName = '#'}
				if(hash[folderName] === undefined){hash[folderName] = [];}
				hash[folderName].push({'id':key,'title':value[0]});
			});
			umylist.globalNicoCacheData = umylist.HashkeySort(hash);
		},function(){});
	},getUnlimitedMyList:function(){
		return umylist.getAjax('/umylist/json',null,'get','json',true,function(){},function(response){
			if(response.status !== undefined && response.status === 'failed'){
				return
			}
			$.each(response, function(key,value) {
				umylist.globalDataUMy[value.id] = value;
			});
		},function(){});
	},getUnlimitedFavMyList:function(){
		return umylist.getAjax('/umylist/mylist/json',null,'get','json',true,function(){},function(response){
			if(response.status !== undefined && response.status === 'failed'){
				//console.log('UnlimitedFavMyList failed',response);
				return
			}
			$.each(response, function(key,value) {
				umylist.globalDataUFav[value.mylistid] = value;
			});
		},function(){});
	},getSelectUMyList:function(exclusionId){
		var str = '';
		str += '<select id="itemSelect" class="uumyselect">';
			$.each(umylist.globalDataUMy, function(key,value) {
				if(value.id !== exclusionId){
					str += '<option value="'+value.id+'">'+value.name+'</option>';
				}
			});
		str += '</select>';
		return str;
	},makeNewFavMyList:function(){
	},makeHome:function(){
		//$('#information').html($('#hideHome').html());
		$('#information').html('');
		$('#list').html('');
		$('#uibutton').hide();
	},makeUnlimitedList:function(mylistid){
		$('#list').html('');
		if(umylist.globalDataUMy[mylistid].movies.length == 0){
			umylist.createAllUIButton('','u');
			$('#information').html('<div class="well uform"><h4>'+umylist.globalDataUMy[mylistid]['name']+'</h4><p>登録数: '+umylist.globalDataUMy[mylistid].movies.length+'</p></div>');
			return;
		}
		$('#information').html('<div class="well uform">処理中です...</div>');
		var midArray = [];
		var mids = '';
		$.each(umylist.globalDataUMy[mylistid].movies, function(key,value) {
			midArray.push(value);
		});
		$.each(midArray, function(key,value) {
			if(
				umylist.globalCacheMovieData[value.threadid] === undefined && 
				umylist.globalCacheMovieData[value.movieid] === undefined
			){
				mids += value.threadid + ',';
			}
		});
		if(mids.length > 0){
			umylist.setGlobalUnlimited(mids.substring(0,mids.length-1),false);
		}
		var list = [];
		$.each(midArray, function(key,value) {
//			list.push(umylist.createMovieItemCheck(umylist.checkId([value.movieid,value.threadid],value.id)));
			list.push(umylist.createMovieItemCheck(umylist.checkId([value.threadid,value.movieid],value.id)));
		});
		umylist.createAllUIButton('','u');
		$('#information').html('<div class="well uform"><h4>'+umylist.globalDataUMy[mylistid]['name']+'</h4><p>登録数: '+umylist.globalDataUMy[mylistid].movies.length+'</p></div>');
		$('#list').html(umylist.createMovieCheck(list));
		list = null;
	},makeUList:function() {
		var str = '';
		str += '<table id="table_u" class="table table-bordered table-hover table-striped utable">';
		str += '<thead><tr class="utr">';
		str += '<!--<td class="span2">ID</td>--><td class="span2">登録動画数</td>';
		str += '<td>名前</td></tr></thead><tbody>';
		var itemlen = 0;
		$.each(umylist.globalDataUMy, function(key, value) {
			str += '<tr><!--<td>'+value.id+'</td>--><td>'+value.movies.length+'</td>';
			str += '<td><a mylist-id="'+value.id+'" db-id="'+value.id+'" href="javascript:void(0);">'+value.name+'</a></td></tr>';
			itemlen++;
		});
		str += '</tbody></table>';
		$('#list').html(str);
		$('#uibutton').hide();
		$('#information').html('<div class="well uform"><h4>Unlimited MyList</h4><p>登録数: '+itemlen+'</p></div>');
	},makeUFavList:function() {
		var str = '';
		str += '<table id="table_f" class="table table-bordered table-hover table-striped utable">';
		str += '<thead><tr class="utr">';
		str += '<!--<td class="span2">ID</td>--><td>名前</td></tr></thead><tbody>';
		var itemlen = 0;
		$.each(umylist.globalDataUFav, function(key, value) {
			str += '<tr><!--<td>'+value.id+'</td>-->';
			str += '<td><a mylist-id="'+value.mylistid+'" db-id="'+value.id+'" href="javascript:void(0);">'+value.name+'</a></td></tr>';
			itemlen++;
		});
		str += '</tbody></table>';
		$('#list').html(str);
		$('#uibutton').hide();
		$('#information').html('<div class="well uform"><h4>UnlimitedFavMyList</h4><p>登録数: '+itemlen+'</p></div>');
	},makeDefList:function(){
		$('#information').html('<div class="well uform">処理中です...</div>');
		$('#list').html('');
		$('#uibutton').hide();
		$.when(umylist.setGlobalDefList()).done(umylist.openCreateDefList);
	},makeMyList:function(elem,type){
		$('#information').html('<div class="well uform">処理中です...</div>');
		$('#list').html('');
		var mid = elem.attr('mylist-id');
		var first = umylist.globalDataMy[mid] === undefined;
		$.when(
			umylist.setGlobalMyList1(mid)
		).done(function(response){
			var str = '<div class="well uform">';
			var mname = umylist.globalDataMy[mid]['title'];
			if(type === 'f'){
				var tname = umylist.globalDataUFav[umylist.data.mylistid]['name'];
				str += '<h4>'+tname+'</h4>';
				if(tname !== mname){str += '<p>元名前: '+umylist.globalDataMy[mid]['title']+'</p>';}
			}else{
				str += '<h4>'+mname+'</h4>';
			}
			str += '<p>ID: '+mid+'</p>'+
				'<p><a href="http://www.nicovideo.jp/user/'+umylist.globalDataMy[mid]['user_id']+'">'+
				umylist.globalDataMy[mid]['user_id']+'</a>さんのマイリスト</p>'+
				'<p>'+umylist.globalDataMy[mid]['description']+'</p>'+
				'</div>';
			$('#information').html(str);
			if(type === 'f'){
				umylist.createAllUIButton(umylist.globalDataMy[mid]['title'],type);
			}else{
				umylist.createAllUIButton('',type);
			}
			if(umylist.globalDataMy[mid]['items'].length > 0){
				var list = [];
				$.each(umylist.globalDataMy[mid]['items'], function(key,value) {
					list.push(umylist.createMovieItemCheck(umylist.checkId(value.id,'')));
				});
				$('#list').html(umylist.createMovieCheck(list));
				list = null;
			}
			if(first)elem.text(elem.text()+' ('+umylist.globalDataMy[mid]['count']+')');
		});
	},makeMyListList:function(){
		$('#information').html('<div class="well uform">処理中です...</div>');
		$('#list').html('');
		$('#uibutton').hide();
		$.when(umylist.setGlobalMyListList()).done(umylist.openCreateMyListList);
	},makeNicoCacheListList:function(){
		var str = '';
		str += '<table id="table_n" class="table table-bordered table-hover table-striped utable">';
		str += '<thead><tr class="utr"><tr><td>名前</td></tr></thead><tbody>';
		if(umylist.globalNicoCacheData['#temp'] !== undefined){
			str += '<tr><td><a href="javascript:void(0);" folder-id="#temp">temp ('+umylist.globalNicoCacheData['#temp'].length+')</a></td></tr>';
		}
		$.each(umylist.globalNicoCacheData,function(key,value){
			if(key !== '#temp'){
				str += '<tr><td><a href="javascript:void(0);" folder-id="'+key+'">'+key+' ('+value.length+')</a></td></tr>';
			}
		});
		str += '</tbody></table>';
		$('#uibutton').hide();
		$('#list').html(str);
		$('#information').html('<div class="well uform"><h4>NicoCache folders</h4></p></div>');
	},makeNicoCacheList:function(name){
		var fname = name;
		if(name === '#')fname = 'トップディレクトリ';
		if(name === '#temp')fname = '一時キャッシュ';
		$('#information').html('<div class="well uform">フォルダ名: '+ fname+'</div>');
		umylist.createAllUIButton('','n');
		var list = [];
		$.each(umylist.globalNicoCacheData[name],function(key,value){
			list.push(umylist.createMovieItemList(value));
		});
		var t = umylist.config.view;
		umylist.config.view = 'list';
		$('#list').html(umylist.createMovieCheck(list));
		umylist.config.view = t;
	},openCreateUnlimitedMyList:function(){
		var list = [];
		$.each(umylist.globalDataUMy, function(key,value) {
			list.push('<li db-id="'+value.id+'"  mylist-id="'+value.id+'"><a href="javascript:void(0);" db-id="'+value.id+'" mylist-id="'+value.id+'">'+value.name+' ('+value.movies.length+')</a></li>');
		});
		$('#sidebar_u').find('ul').append(list.join('\n'));
		list = null;
	},openCreateUnlimitedFavMyList:function(){
		var list = [];
		$.each(umylist.globalDataUFav, function(key,value) {
			list.push('<li db-id="'+value.id+'" mylist-id="'+value.mylistid+'"><a href="javascript:void(0);" db-id="'+value.id+'" mylist-id="'+value.mylistid+'">'+value.name+'</a></li>');
		});
		$('#sidebar_f').find('ul').append(list.join('\n'));
		list = null;
	},openCreateDefList:function(response,listFlag){
		var itemlen = umylist.globalDataDef['items'].length;
		$('#information').html('<div class="well uform"><h4>とりあえずマイリスト</h4><p>登録数: '+itemlen+'</p></div>');
		if(itemlen > 0){
			if(listFlag === undefined || listFlag === 'success' || listFlag === true){
				var list = [];
				$.each(umylist.globalDataDef['items'], function(key,value) {
					list.push(umylist.createMovieItemCheck(umylist.checkId(value,'')));
				});
				umylist.createAllUIButton('','d');
				$('#list').html(umylist.createMovieCheck(list));
				list = null;
			}
		}
		var sd = $('#sidebar_d');
		if(sd.find('li').length === 1){
			if(umylist.config.column === 2){
				sd.show(0);
			}
			sd.find('ul').append('<li><a href="javascript:void(0);">とりあえずマイリスト ('+itemlen+')</a></li>')
		}
	},openCreateMyListList:function(response){
		$('#list').html('');
		var list = [];
		$.each(umylist.globalDataList, function(key,value) {
			list.push('<li><a href="javascript:void(0);" mylist-id="'+umylist.globalDataList[key]['id']+'">'+umylist.globalDataList[key]['title']+'</a></li>')
		});
		var sm = $('#sidebar_m');
		if(sm.find('li').length === 1){
			if(umylist.config.column === 2){
				sm.show(0);
			}
			sm.find('ul').append(list.join('\n'));
		}
		$('#information').html('<div class="well uform"><h4>公式マイリスト</h4><p>登録数: '+list.length+'</p></div>');
		var str = '';
		str += '<table id="table_m" class="table table-bordered table-hover table-striped utable">';
		str += '<thead><tr class="utr">';
		str += '<!--<td class="span2">ID</td>--><td>名前</td></tr></thead><tbody>';
		var itemlen = 0;
		$.each(umylist.globalDataList, function(key, value) {
			str += '<tr><!--<td>'+key+'</td>-->';
			str += '<td><a mylist-id="'+umylist.globalDataList[key]['id']+'" href="javascript:void(0);">'+umylist.globalDataList[key]['title']+'</a></td></tr>';
			itemlen++;
		});
		str += '</tbody></table>';
		$('#list').html(str);
		list = null;
	},openCreateNicoCache:function(){
		var sn = $('#sidebar_n');
		if(sn.find('li').length === 1){
			sn.show(0);
			var list = [];
			if(umylist.globalNicoCacheData['#temp'] !== undefined){
				list.push('<li><a href="javascript:void(0);" folder-id="#temp">temp ('+umylist.globalNicoCacheData['#temp'].length+')</a></li>')
				list.push('<li class="divider"></li>');
			}
			$.each(umylist.globalNicoCacheData,function(key,value){
				if(key !== '#temp'){
					list.push('<li><a href="javascript:void(0);" folder-id="'+key+'">'+key+' ('+value.length+')</a></li>')
				}
			});
			sn.find('ul').append(list.join('\n'));
		}
	},checkFetchStatus:function(){
		umylist.getAjax('/cache/fetch',{'status':'all'},'get','text',true,function(){},function(response){
			var ids = response.split('\r\n');
			ids.pop();
			var iss = false;
			$.each(ids, function(key,value) {
				var str = value.match(/([a-z]{2}\d+)(?:low)?: (\S+) (.+)/);
				if(str !== null){
					var us = 'width:';
					var elem = $('#bar_'+str[1]);
					if(str[3] === 'wait'){
						us += '0%';
						iss = true;
					}else if(str[3] === 'done.'){
						us += '100%';
						elem.parent().removeClass('active');
						elem.parent().removeClass('progress-striped');
					}else if(str[3] === 'error.'){
					}else if(str[2] === 'deleted=1'){
					}else{
						iss = true;
						us += str[3];
					}
					$('#bar_'+str[1]).attr('style',us);
				}
			});
			if((!iss || ids.length == 0) && umylist.timerStart){
				clearInterval(umylist.timer);
				umylist.timerStart = false;
			}
		},function(){});
	},checkOpenModal:function(elem){
		$('#buttonModal').find('.modal-footer').hide();
		var dtype = elem.attr('data-type');
		var did = elem.attr('data-id');
		var dth = elem.attr('data-thread-id');
		var ddbid = elem.attr('data-db-id');
		var mtype = umylist.data.mylisttype;
		var mid = umylist.data.mylistid;
		umylist.data.datatype = dtype;
		umylist.data.dbid = ddbid;
		umylist.data.dataid = did;
		umylist.data.datathreadid = dth;
		var strheader = '';
		var strbody = '';
		if(dtype === 'itemdel'){
			strheader = '削除';
			strbody += umylist.createMovieItemBlock(umylist.checkId([dth,did],ddbid),false,false);
			strbody += '<p>上記の動画を "'+umylist.globalDataUMy[mid]['name']+'" から削除しますか？</p>';
			$('#buttonModal').find('.modal-footer').show();
		}else if(dtype === 'itemcopy'){
			strheader = '複製';
			strbody += umylist.createMovieItemBlock(umylist.checkId([dth,did],ddbid),false,false);
			strbody += '<p>上記の動画を "'+umylist.globalDataUMy[mid]['name']+'" からどこに複製しますか？</p>';
			strbody += umylist.getSelectUMyList(mid*1);
			var so = $(strbody).find('option').first();
			umylist.data.mylisttoid = so.val();
			strbody += '<p class="upselect">"'+so.html()+'" でよろしいでしょうか？</p>';
			$('#buttonModal').find('.modal-footer').show();
		}else if(dtype === 'itemmove'){
			strheader = '移動';
			strbody += umylist.createMovieItemBlock(umylist.checkId([dth,did],ddbid),false,false);
			strbody += '<p>上記の動画を "'+umylist.globalDataUMy[mid]['name']+'" からどこに移動させますか？</p>';
			strbody += umylist.getSelectUMyList(mid*1);
			var so = $(strbody).find('option').first();
			umylist.data.mylisttoid = so.val();
			strbody += '<p class="upselect">"'+so.html()+'" でよろしいでしょうか？</p>';
			$('#buttonModal').find('.modal-footer').show();
		}else if(dtype === 'itemregister'){
			strheader = '登録';
			if(did === '' || dth === '' || did == 'undefined' || dth == 'undefined'){
				if(did === '' || did === undefined)delete umylist.globalCacheMovieData[did];
				if(dth === '' || dth === undefined)delete umylist.globalCacheMovieData[dth];
				var nn = dth;
				if(dth === '' || dth == 'undefined'){nn = did;}else{nn = dth;}
				$.when(
					umylist.setGlobalUnlimited(nn,true)
				).done(function(response){
					var cthis = $(response);
					res = umylist.globalCacheMovieData[nn];
					if(res === undefined){
						var vid = cthis.find('video > id').text();
						res = umylist.globalCacheMovieData[vid];
						umylist.data.dataid = vid;
					}
					if(res === undefined){
						var tid = cthis.find('thread > id').text();
						res = umylist.globalCacheMovieData[tid];
						umylist.data.dataid = tid;
					}
					if(res === undefined){
						$('#buttonModal').find('.modal-footer').hide();
					}else{
						umylist.data.dataid = res.id;
						umylist.data.datathreadid = res.thread_id;
						strbody = umylist.createMovieItemBlock(res,false,false);
						strbody += '<p>上記の動画をどこに登録しますか？</p>';
						strbody += umylist.getSelectUMyList('');
						var so = $(strbody).find('option').first();
						umylist.data.mylisttoid = so.val();
						strbody += '<p class="upselect">"'+so.html()+'" でよろしいでしょうか？</p>';
						$('#buttonModal').find('.modal-body').html(strbody);
						$('#buttonModal').find('.modal-footer').show();
					}
				});
				strbody = '取得中....';
			}else{
				var res = umylist.globalCacheMovieData[did];
				if(res === undefined){
					res = umylist.globalCacheMovieData[dth];
				}
				strbody += umylist.createMovieItemBlock(umylist.checkId([dth,did],ddbid),false,false);
				strbody += '<p>上記の動画をどこに登録しますか？</p>';
				strbody += umylist.getSelectUMyList('');
				var so = $(strbody).find('option').first();
				umylist.data.mylisttoid = so.val();
				strbody += '<p class="upselect">"'+so.html()+'" でよろしいでしょうか？</p>';
				$('#buttonModal').find('.modal-footer').show();
			}
		}else if(dtype === 'itemfetch'){
			umylist.getAjax('/cache/fetch?'+did,null,'get','text',true,function(){},function(response){
				if(response === 'OK fetch accepted.'){
				}else if(response === 'OK already cached.'){return;
				}else if(response === 'OK now caching.'){return;
				}else{/*console.log(response);*/return}
				elem.parent().append('<div class="progress progress-striped uprogress active"><div id="bar_'+did+'" class="bar" style="width: 0%;"></div></div>');
				if(!umylist.timerStart){
					umylist.timer = setInterval(umylist.checkFetchStatus,umylist.config.setIntervalTime);
					umylist.timerStart = true;
				}
			},function(){});
			return;
		}else if(dtype === 'itemcacherm'){
			umylist.getAjax('/cache/ajax_rm?'+did,null,'get','text',true,function(){},function(response){},function(){});
			return;
		}else if(dtype === 'alldel_u'){
			strheader = '削除';
			strbody = '<p>"'+umylist.globalDataUMy[mid]['name']+' を削除しますか？</p>';
			$('#buttonModal').find('.modal-footer').show();
		}else if(dtype === 'allrename_u'){
			strheader = '変更';
			var ip = $('input');
			var nn = ip.val();
			if(nn === ''){nn = $('input').attr('placeholder');}
			umylist.data.dataname = nn;
			strbody = '<p>"'+umylist.globalDataUMy[mid]['name']+'" を "'+nn+'"に変更しますか？</p>';
			$('#buttonModal').find('.modal-footer').show();
		}else if(dtype === 'allcreate_u'){
			strheader = '作成';
			var ip = $('input');
			var nn = ip.val();
			if(nn === ''){nn = $('input').attr('placeholder');}
			umylist.data.dataname = nn;
			strbody = '<p>"'+nn+'" を作成しますか？</p>';
			$('#buttonModal').find('.modal-footer').show();
		}else if(dtype === 'allappend_u'){
			strheader = '追加';
			var ip = $('input');
			var nn = ip.val();
			var str = nn.match(/^([a-z]{2}\d+|\d+)$/);
			if(nn === '' || str == null){
				$('#buttonModal').find('.modal-footer').hide();
				strbody = '<h4>エラー！</h4><p>val: '+nn+'</p><p>動画IDがありません。</p>';
			}else{
				umylist.data.dataid = nn;
				strbody = '<p>マイリスト:"'+umylist.globalDataUMy[umylist.data.mylistid]['name']+'" に "'+nn+'" を追加しますか？</p>';
				var res = umylist.globalCacheMovieData[nn];
				if(res === undefined){
					$.when(
						umylist.setGlobalUnlimited(nn,true)
					).done(function(response){
						var cthis = $(response);
						res = umylist.globalCacheMovieData[nn];
						if(res === undefined){
							var vid = cthis.find('video > id').text();
							res = umylist.globalCacheMovieData[vid];
							umylist.data.dataid = vid;
						}
						if(res === undefined){
							var tid = cthis.find('thread > id').text();
							res = umylist.globalCacheMovieData[tid];
							umylist.data.dataid = tid;
						}
						if(res === undefined){
							$('#buttonModal').find('.modal-footer').hide();
						}else{
							umylist.data.datathreadid = res.thread_id;
							$('#buttonModal').append(umylist.createMovieItemBlock(res,false,false));
							$('#buttonModal').find('.modal-footer').show();
						}
					});
				}else{
					umylist.data.datathreadid = res.thread_id;
					$('#buttonModal').append(umylist.createMovieItemBlock(res,false,false));
					$('#buttonModal').find('.modal-footer').show();
				}
			}
		}else if(dtype === 'allappend_f'){
			strheader = '追加';
			var ip = $('input');
			var nn = ip.val();
			var str = nn.match(/^(\d+)$/);
			umylist.data.mylistid = nn;
			if(nn === '' || str == null){
				$('#buttonModal').find('.modal-footer').hide();
				strbody = '<h4>エラー！</h4><p>val: '+nn+'</p><p>マイリストIDがありません。</p>';
			}else{
				strbody = '<p>"'+nn+'" を追加しますか？</p>';
				var res = umylist.globalDataMy[nn];
				if(res === undefined){
					$.when(
						umylist.setGlobalMyList1(nn)
					).done(function(response){
						res = umylist.globalDataMy[nn];
						if(res === undefined){
							$('#buttonModal').find('.modal-footer').hide();
						}else{
							var str = '<div class="well">';
							str += '<h4>'+res.title+'</h4>';
							str += '<p>'+res.description+'</p>';
							str += '<p>動画数'+res.items.length+'</p>';
							str += '</div>';
							umylist.data.mylistname = res.title;
							$('#buttonModal').append(str);
							$('#buttonModal').find('.modal-footer').show();
						}
					});
				}else{
					var str = '<div class="well">';
					str += '<h4>'+res.title+'</h4>';
					str += '<p>'+res.description+'</p>';
					str += '<p>動画数'+res.items.length+'</p>';
					str += '</div>';
					umylist.data.mylistname = res.title;
					$('#buttonModal').append(str);
					$('#buttonModal').find('.modal-footer').show();
				}
			}
		}else if(dtype === 'alldel_f'){
			strheader = '削除';
			strbody = '<p>"'+umylist.globalDataMy[umylist.data.mylistid]['title']+' を削除しますか？</p>';
			$('#buttonModal').find('.modal-footer').show();
		}else if(dtype === 'allrename_f'){
			strheader = '変更';
			var ip = $('input');
			var nn = ip.val();
			if(nn === ''){nn = $('input').attr('placeholder');}
			umylist.data.mylistname = nn;
			strbody = '<p>"'+umylist.globalDataUFav[umylist.data.mylistid]['name']+'" を "'+nn+'"に変更しますか？</p>';
			$('#buttonModal').find('.modal-footer').show();
		}else{
			$('#buttonModal').find('.modal-header').html('<h3>エラー</h3>');
			$('#buttonModal').find('.modal-body').html('<p>'+dtype+'</p>');
			return;
		}
		$('#buttonModal').find('.modal-header').html('<h3>'+strheader+'</h3>');
		$('#buttonModal').find('.modal-body').html(strbody);
	},checkModalAnswer:function(ans){
		if(ans !== 'o'){return;}
		var dtype = umylist.data.datatype;
		var did = umylist.data.dataid;
		var ddbid = umylist.data.dbid;
		var tid = umylist.data.datathreadid;
		var dname = umylist.data.dataname;
		var mid = umylist.data.mylistid;
		var mtid = umylist.data.mylisttoid;
		var mtype = umylist.data.mylisttype;
		var mname = umylist.data.mylistname;
		//
		if(dtype === 'itemdel'){
			umylist.getAjax('/umylist/remove',{'id':ddbid},'get','json',true,function(){},function(response){
				var strbody = '';
				if(response.status === 'overlap'){
					strbody = '重複';
				}else if(response.status === 'failed'){
					strbody = '失敗';
				}else if(response.status === 'invalidName' || response.status === 'invalidMylist'){
					strbody = 'エラー';
				}else if(response.status === 'succeeded'){
					$('#list').find('div[data-db-id='+ddbid+']').remove();
					var aid = -1;
					$.each(umylist.globalDataUMy[mid]['movies'], function(key,value){if(value.id === ddbid){aid = key;return false;}});
					if(aid >= 0){
						umylist.globalDataUMy[mid]['movies'].splice(aid,1);
					}
					$('#sidebar_u').find('ul').find('li[mylist-id='+mid+']').html('<a href="javascript:void(0);" mylist-id="'+mid+'">'+umylist.globalDataUMy[mid].name+' ('+umylist.globalDataUMy[mid].movies.length+')</a>');
					$('#information').find('p').html('登録数: '+umylist.globalDataUMy[mid].movies.length);
					strbody = '成功';
				}else{
					strbody = '不明';
				}
				$('#buttonModal').find('.modal-header').html('<h3>削除</h3>');
				$('#buttonModal').find('.modal-body').html(strbody);
				$('#buttonModal').find('.modal-footer').hide();
				if(umylist.config.resultModal){
					$('#buttonModal').modal('show');
				}
			},function(){});
		}else if(dtype === 'itemcopy'){
			umylist.getAjax('/umylist/copy',{'id':ddbid,'from':mid,'to':mtid},'get','json',true,function(){},function(response){
				var strbody = '';
				if(response.status === 'overlap'){
					strbody = '重複';
				}else if(response.status === 'failed'){
					strbody = '失敗';
				}else if(response.status === 'invalidName' || response.status === 'invalidMylist'){
					strbody = 'エラー';
				}else if(response.status === 'succeeded'){
					umylist.globalDataUMy[mtid].movies.push({'id':response.id,'movieid':response.movieid,'threadid':response.threadid});
					$('#sidebar_u').find('ul').find('li[mylist-id='+mtid+']').html('<a href="javascript:void(0);" mylist-id="'+mtid+'">'+umylist.globalDataUMy[mtid].name+' ('+umylist.globalDataUMy[mtid].movies.length+')</a>');
					$('#information').find('p').html('登録数: '+umylist.globalDataUMy[mid].movies.length);
					strbody = '成功';
				}else{
					strbody = '不明';
				}
				$('#buttonModal').find('.modal-header').html('<h3>複製</h3>');
				$('#buttonModal').find('.modal-body').html(strbody);
				$('#buttonModal').find('.modal-footer').hide();
				if(umylist.config.resultModal){
					$('#buttonModal').modal('show');
				}
			},function(){});
		}else if(dtype === 'itemmove'){
			umylist.getAjax('/umylist/move',{'id':ddbid,'from':mid,'to':mtid},'get','json',true,function(){},function(response){
				var strbody = '';
				if(response.status === 'overlap'){
					strbody = '重複';
				}else if(response.status === 'failed'){
					strbody = '失敗';
				}else if(response.status === 'invalidName' || response.status === 'invalidMylist'){
					strbody = 'エラー';
				}else if(response.status === 'succeeded'){
					$('#list').find('div[data-db-id='+ddbid+']').remove();
					var aid = -1;
					$.each(umylist.globalDataUMy[mid]['movies'], function(key,value){if(value.id === ddbid){aid = key;return false;}});
					if(aid >= 0){
						umylist.globalDataUMy[mid]['movies'].splice(aid,1);
					}
					umylist.globalDataUMy[mtid].movies.push({'id':response.id,'movieid':response.movieid,'threadid':response.threadid});
					$('#sidebar_u').find('ul').find('li[mylist-id='+mid+']').html('<a href="javascript:void(0);" mylist-id="'+mid+'">'+umylist.globalDataUMy[mid].name+' ('+umylist.globalDataUMy[mid].movies.length+')</a>');
					$('#sidebar_u').find('ul').find('li[mylist-id='+mtid+']').html('<a href="javascript:void(0);" mylist-id="'+mtid+'">'+umylist.globalDataUMy[mtid].name+' ('+umylist.globalDataUMy[mtid].movies.length+')</a>');
					$('#information').find('p').html('登録数: '+umylist.globalDataUMy[mid].movies.length);
					strbody = '成功';
				}else{
					strbody = '不明';
				}
				$('#buttonModal').find('.modal-header').html('<h3>移動</h3>');
				$('#buttonModal').find('.modal-body').html(strbody);
				$('#buttonModal').find('.modal-footer').hide();
				if(umylist.config.resultModal){
					$('#buttonModal').modal('show');
				}
			},function(){});
		}else if(dtype === 'itemregister'){
			umylist.getAjax('/umylist/add',{'mylist':mtid,'mid':did,'tid':tid},'get','json',true,function(){},function(response){
				var strbody = '';
				if(response.status === 'overlap'){
					strbody = '重複';
				}else if(response.status === 'failed'){
					strbody = '失敗';
				}else if(response.status === 'invalidName' || response.status === 'invalidMylist'){
					strbody = 'エラー';
				}else if(response.status === 'succeeded'){
					umylist.globalDataUMy[response.mylist].movies.push({'id':response.id,'movieid':response.movieid,'threadid':response.threadid});
					$('#sidebar_u').find('ul').find('li[mylist-id='+response.mylist+']').html('<a href="javascript:void(0);" mylist-id="'+response.mylist+'">'+umylist.globalDataUMy[response.mylist].name+' ('+umylist.globalDataUMy[response.mylist].movies.length+')</a>');
					strbody = '成功';
				}else{
					strbody = '不明';
				}
				$('#buttonModal').find('.modal-header').html('<h3>登録</h3>');
				$('#buttonModal').find('.modal-body').html(strbody);
				$('#buttonModal').find('.modal-footer').hide();
				if(umylist.config.resultModal){
					$('#buttonModal').modal('show');
				}
			},function(){});
		}else if(dtype === 'alldel_u'){
			umylist.getAjax('/umylist/mremove',{'mylist':mid},'get','json',true,function(){},function(response){
				var strbody = '';
				if(response.status === 'overlap'){
					strbody = '重複';
				}else if(response.status === 'failed'){
					strbody = '失敗';
				}else if(response.status === 'invalidName' || response.status === 'invalidMylist'){
					strbody = 'エラー';
				}else if(response.status === 'succeeded'){
					$('#sidebar_u').find('li').find('a[mylist-id='+mid+']').remove();
					delete umylist.globalDataUMy[mid];
					strbody = '成功';
				}else{
					strbody = '不明';
				}
				$('#buttonModal').find('.modal-header').html('<h3>削除</h3>');
				$('#buttonModal').find('.modal-body').html(strbody);
				$('#buttonModal').find('.modal-footer').hide();
				if(umylist.config.resultModal){
					$('#buttonModal').modal('show');
				}
			},function(){});
		}else if(dtype === 'allrename_u'){
			umylist.getAjax('/umylist/rename',{'mylist':mid,'name':dname},'get','json',true,function(){},function(response){
				var strbody = '';
				if(response.status === 'overlap'){
					strbody = '重複';
				}else if(response.status === 'failed'){
					strbody = '失敗';
				}else if(response.status === 'invalidName' || response.status === 'invalidMylist'){
					strbody = 'エラー';
				}else if(response.status === 'succeeded'){
					$('#sidebar_u a[mylist-id='+response.mylist+']').html(response.name+' ('+umylist.globalDataUMy[response.mylist]['movies'].length+')');
					$('#information').find('h4').html(response.name);
					umylist.globalDataUMy[mid]['name'] = response.name;
					strbody = '成功';
				}else{
					strbody = '不明';
				}
				$('#buttonModal').find('.modal-header').html('<h3>変更</h3>');
				$('#buttonModal').find('.modal-body').html(strbody);
				$('#buttonModal').find('.modal-footer').hide();
				if(umylist.config.resultModal){
					$('#buttonModal').modal('show');
				}
			},function(){});
		}else if(dtype === 'allcreate_u'){
			umylist.getAjax('/umylist/madd',{'name':dname},'get','json',true,function(){},function(response){
				var strbody = '';
				if(response.status === 'overlap'){
					strbody = '重複';
				}else if(response.status === 'failed'){
					strbody = '失敗';
				}else if(response.status === 'invalidName' || response.status === 'invalidMylist'){
					strbody = 'エラー';
				}else if(response.status === 'succeeded'){
					$('#sidebar_u').find('ul').append('<li><a href="javascript:void(0);" mylist-id="'+response.mylist+'">'+response.name+' (0)</a></li>');
					umylist.globalDataUMy[response.mylist] = {'id':response.mylist,'name':dname,'movies':[]};
					strbody = '成功';
				}else{
					strbody = '不明';
				}
				$('#buttonModal').find('.modal-header').html('<h3>作成</h3>');
				$('#buttonModal').find('.modal-body').html(strbody);
				$('#buttonModal').find('.modal-footer').hide();
				if(umylist.config.resultModal){
					$('#buttonModal').modal('show');
				}
			},function(){});
		}else if(dtype === 'allappend_u'){
			umylist.getAjax('/umylist/add',{'mylist':mid,'mid':did,'tid':tid},'get','json',true,function(){},function(response){
				var strbody = '';
				if(response.status === 'overlap'){
					strbody = '重複';
				}else if(response.status === 'failed'){
					strbody = '失敗';
				}else if(response.status === 'invalidName' || response.status === 'invalidMylist'){
					strbody = 'エラー';
				}else if(response.status === 'succeeded'){
					$('#list').prepend(umylist.createMovieCheck([umylist.createMovieItemCheck(umylist.checkId([response.threadid,response.movieid],response.id))]));
					umylist.globalDataUMy[response.mylist].movies.push({'id':response.id,'movieid':response.movieid,'threadid':response.threadid});
					$('#sidebar_u').find('ul').find('li[mylist-id='+response.mylist+']').html('<a href="javascript:void(0);" mylist-id="'+response.mylist+'">'+umylist.globalDataUMy[response.mylist].name+' ('+umylist.globalDataUMy[response.mylist].movies.length+')</a>');
					$('#information').find('p').html('登録数: '+umylist.globalDataUMy[response.mylist].movies.length);
					strbody = '成功';
				}else{
					strbody = '不明';
				}
				$('#buttonModal').find('.modal-header').html('<h3>追加</h3>');
				$('#buttonModal').find('.modal-body').html(strbody);
				$('#buttonModal').find('.modal-footer').hide();
				if(umylist.config.resultModal){
					$('#buttonModal').modal('show');
				}
			},function(){});
		}else if(dtype === 'alldel_f'){
			umylist.getAjax('/umylist/mylist/remove',{'mylist':mid},'get','json',true,function(){},function(response){
				var strbody = '';
				if(response.status === 'overlap'){
					strbody = '重複';
				}else if(response.status === 'failed'){
					strbody = '失敗';
				}else if(response.status === 'invalidName' || response.status === 'invalidMylist'){
					strbody = 'エラー';
				}else if(response.status === 'succeeded'){
					$('#sidebar_f').find('ul').find('li[mylist-id='+mid+']').remove();
					delete umylist.globalDataUFav[mid];
					strbody = '成功';
				}else{
					strbody = '不明';
				}
				$('#buttonModal').find('.modal-header').html('<h3>削除</h3>');
				$('#buttonModal').find('.modal-body').html(strbody);
				$('#buttonModal').find('.modal-footer').hide();
				if(umylist.config.resultModal){
					$('#buttonModal').modal('show');
				}
			},function(){});
		}else if(dtype === 'allrename_f'){
			umylist.getAjax('/umylist/mylist/rename',{'mylist':mid,'name':mname},'get','json',true,function(){},function(response){
				var strbody = '';
				if(response.status === 'overlap'){
					strbody = '重複';
				}else if(response.status === 'failed'){
					strbody = '失敗';
				}else if(response.status === 'invalidName' || response.status === 'invalidMylist'){
					strbody = 'エラー';
				}else if(response.status === 'succeeded'){
					$('#sidebar_f').find('ul').find('li[mylist-id='+mid+'] a').html(response.name+ '('+umylist.globalDataMy[umylist.data.mylistid]['count']+')')
					$('#information').find('h4').html(response.name);
					umylist.globalDataUFav[umylist.data.mylistid]['name'] = response.name;
					strbody = '成功';
				}else{
					strbody = '不明';
				}
				$('#buttonModal').find('.modal-header').html('<h3>変更</h3>');
				$('#buttonModal').find('.modal-body').html(strbody);
				$('#buttonModal').find('.modal-footer').hide();
				if(umylist.config.resultModal){
					$('#buttonModal').modal('show');
				}
			},function(){});
		}else if(dtype === 'allappend_f'){
			umylist.getAjax('/umylist/mylist/add',{'mylist':mid,'name':mname},'get','json',true,function(){},function(response){
				var strbody = '';
				if(response.status === 'overlap'){
					strbody = '重複';
				}else if(response.status === 'failed'){
					strbody = '失敗';
				}else if(response.status === 'invalidName' || response.status === 'invalidMylist'){
					strbody = 'エラー';
				}else if(response.status === 'succeeded'){
					$('#sidebar_f').find('ul').append('<li db-id="'+response.mylist+'" mylist-id="'+umylist.data.mylistid+'"><a href="javascript:void(0);" db-id="'+response.mylist+'" mylist-id="'+umylist.data.mylistid+'">'+response.name+' ('+umylist.globalDataMy[umylist.data.mylistid]['count']+')</a></li>');
					strbody = '成功';
				}else{
					strbody = '不明';
				}
				$('#buttonModal').find('.modal-header').html('<h3>追加</h3>');
				$('#buttonModal').find('.modal-body').html(strbody);
				$('#buttonModal').find('.modal-footer').hide();
				if(umylist.config.resultModal){
					$('#buttonModal').modal('show');
				}
			},function(){});
		}else{
			//console.log('Error',dtype);
			$('#buttonModal').find('.modal-header').html('<h3>エラー</h3>');
			$('#buttonModal').find('.modal-body').html('<p>'+dtype+'</p>');
			return;
		}
	},initialize:function(){
		if(umylist.config.column === 1){
			$('#menu').hide();
			$('#uibutton').removeClass('span9').addClass('span12');
			$('#information').removeClass('span9').addClass('span12');
			$('#list').removeClass('span9').addClass('span12');
		}
		umylist.openCreateMenu();
		/* synchronized になったらこっち */
		/*
		if(umylist.config.autoLoadOfficialMyList){
			$.when(umylist.getNicoCacheList(),umylist.getNicoCacheTempList(),umylist.getUnlimitedMyList(),umylist.getUnlimitedFavMyList(),umylist.setGlobalDefList(),umylist.setGlobalMyListList()).done(umylist.initialize_loaddone);
		}else{
			$.when(umylist.getNicoCacheList(),umylist.getNicoCacheTempList(),umylist.getUnlimitedMyList(),umylist.getUnlimitedFavMyList()).done(umylist.initialize_loaddone);
		}
		*/
		/* synchronized がなかったらこっち */
		$.when(umylist.getNicoCacheList(),umylist.getUnlimitedMyList()).done(function(response){
			if(umylist.config.autoLoadOfficialMyList){
				$.when(umylist.getNicoCacheTempList(),umylist.getUnlimitedFavMyList(),umylist.setGlobalDefList(),umylist.setGlobalMyListList()).done(umylist.initialize_loaddone);
			}else{
				$.when(umylist.getNicoCacheTempList(),umylist.getUnlimitedFavMyList()).done(umylist.initialize_loaddone);
			}
		});
		/* ぶっちゃけどっちでもいいけど ^^ 数msの違い */
	},initialize_loaddone:function(response){
		umylist.openCreateUnlimitedMyList();
		umylist.openCreateUnlimitedFavMyList();
		umylist.openCreateNicoCache();
		if(umylist.config.autoLoadOfficialMyList){
			umylist.openCreateDefList('',true);
			umylist.openCreateMyListList();
		}
		umylist.makeHome();
	},openCreateMenu:function(){
		var list = [];
		list.push('<div id="sidebar_u" class="well sidebar-nav"><li class="nav-header">Unlimited MyList</li><ul class="nav nav-list"></ul></div>');
		list.push('<div id="sidebar_f" class="well sidebar-nav"><li class="nav-header">Unlimited Fav MyList</li><ul class="nav nav-list"></ul></div>');
		list.push('<div id="sidebar_d" class="well sidebar-nav hide"><li class="nav-header">Def MyList</li><ul class="nav nav-list"></ul></div>');
		list.push('<div id="sidebar_m" class="well sidebar-nav hide"><li class="nav-header">MyList</li><ul class="nav nav-list"></ul></div>');
		list.push('<div id="sidebar_n" class="well sidebar-nav"><li class="nav-header">NicoCache</li><ul class="nav nav-list"></ul></div>');
		$('#menu').append(list.join(''));
	},itemSort:function(val){
		var v = val.split('_');
		var svalue = v[0];
		var soption = v[1];
		var tmp = [];
		var key = '';
		var uthis = null;
		$('#list').find('.movie').each(function(){
			uthis = $(this);
			if(svalue === 'id'){
				key = uthis.attr('data-id').replace(/^\D+/g,'');
			}else if(svalue === 'title'){
				key = uthis.find('.title > a').html();
			}else if(svalue === 'date'){
				key = uthis.find('.first_retrieve').html();
			}else if(svalue === 'view'){
				key = uthis.find('.view').html().split(':')[1].replace(/,/g, '');
			}else if(svalue === 'res'){
				key = uthis.find('.res').html().split(':')[1].replace(/,/g, '');
			}else if(svalue === 'mylist'){
				key = uthis.find('.mylist').html().split(':')[1].replace(/,/g, '');
			}else if(svalue === 'time'){
				key = uthis.find('.time').html().replace(/:/g, '');
			}else{
				return;
			}
			tmp.push({'key':key,'value':uthis});
		});
		if(tmp.length == 0)return;
		var etc = [];
		$('#list').find('.uform').each(function(){etc.push($(this))});
		$('#list').html('');
		tmp.sort(function(a,b){var aa = null;var bb = null;if(svalue === 'title'){aa=a.key.toString().toLowerCase();bb=b.key.toString().toLowerCase();}else{aa=a.key*1;bb=b.key*1;}if(soption === 'sort'){return (aa>bb?1:-1);}else{return (aa>bb?-1:1);}});
		var list = [];
		$.each(tmp, function(key,value) {
			list.push(value['value']);
		});
		$('#list').html(etc);
		$('#list').append(list);
	}
};
$(function(){
	umylist.initialize();
	$(document).on('click', '#sidebar_u a', function(){
		var mid = $(this).attr('mylist-id');
		umylist.data.mylisttype = 'u';
		umylist.data.mylistid = mid;
		umylist.makeUnlimitedList(mid);
	});
	$(document).on('click', '#sidebar_f a', function(){
		umylist.data.mylisttype = 'f';
		umylist.data.mylistid = $(this).attr('mylist-id');
		umylist.data.dbid = $(this).attr('db-id');
		umylist.makeMyList($(this),'f');
	});
	$(document).on('click', '#sidebar_m a', function(){
		umylist.data.mylisttype = 'm';
		umylist.data.mylistid = $(this).attr('mylist-id');
		umylist.makeMyList($(this),'m');
	});
	$(document).on('click', '#sidebar_d a', function(){
		umylist.data.mylisttype = 'd';
		umylist.data.mylistid = '';
		umylist.makeDefList();
	});
	$(document).on('click', '#sidebar_n a', function(){
		umylist.data.mylisttype = 'n';
		umylist.data.mylistid = $(this).attr('folder-id');
		umylist.makeNicoCacheList($(this).attr('folder-id'));
	});
	//
	$(document).on('click', '#table_u a', function(){
		var mid = $(this).attr('mylist-id');
		umylist.data.mylisttype = 'u';
		umylist.data.mylistid = mid;
		umylist.makeUnlimitedList(mid);
	});
	$(document).on('click', '#table_f a', function(){
		umylist.data.mylisttype = 'f';
		umylist.data.mylistid = $(this).attr('mylist-id');
		umylist.data.dbid = $(this).attr('db-id');
		umylist.makeMyList($(this),'f');
	});
	$(document).on('click', '#table_m a', function(){
		umylist.data.mylisttype = 'm';
		umylist.data.mylistid = $(this).attr('mylist-id');
		umylist.makeMyList($(this),'m');
	});
	$(document).on('click', '#table_n a', function(){
		umylist.data.mylisttype = 'n';
		umylist.data.mylistid = $(this).attr('folder-id');
		umylist.makeNicoCacheList($(this).attr('folder-id'));
	});
	//
	$(document).on('click', '.dropdown a', function(){
		umylist.toggleOptionCheck($(this).attr('option-id'));
	});
	$(document).on('click', '.openModalButtons button', function(){
		umylist.checkOpenModal($(this));
	});
//	$(document).on('click', '.movie', function(){
//		if($('#buttonSelect').hasClass('btn-danger')){
//			$(this).toggleClass('uselected');
//		}
//	});
//	$(document).on('click', '#buttonSelect', function(){
//		$('#itemAllSelect').toggle();
//		var uthis = $(this);
//		if(uthis.hasClass('btn-danger')){
//			$('button[data-type=allallselect]').addClass('btn-primary').removeClass('btn-danger').html('全選択');
//		}
//		uthis.toggleClass('btn-primary');
//		uthis.toggleClass('btn-danger');
//	});
	$(document).on('click', '#buttonSort', function(){
		$('#itemSort').toggle();
		var uthis = $(this);
		uthis.toggleClass('btn-primary');
		uthis.toggleClass('btn-danger');
	});
	$(document).on('click', '#buttonSortGo', function(){
		umylist.itemSort($('.uselect').val());
	});
	$(document).on('click', 'button[data-type=allallselect]', function(){
		var uthis = $(this);
		if(uthis.hasClass('btn-danger')){
			uthis.html('全選択');
		}else{
			uthis.html('全解除');
		}
		uthis.toggleClass('btn-primary').toggleClass('btn-danger');
	});
	$(document).on('change', '#itemSelect', function() {
		var ss = $(this).children(':selected');
		umylist.data.mylisttoid = ss.val();
		$('.modal-body').find('p.upselect').html('"'+ss.html()+'" でよろしいでしょうか？');
	});
	$(document).on('click', '.nav-header', function(){
		$(this).next().toggle();
	});
	$('#buttonModal').on('click', 'button', function(){
		umylist.checkModalAnswer($(this).attr('data-name'));
	});
    $('#buttonModal').on('hidden', function () {
		$('#buttonModal').find('.well').remove();
	});
//	$('#navHome').on('click', function(){
//		umylist.makeHome();
//	});
	$('#navDef').on('click', function(){
		umylist.data.mylisttype = 'd';
		umylist.data.mylistid = '';
		umylist.makeDefList();
	});
	$('#navU').on('click', function(){
		umylist.data.mylisttype = '';
		umylist.data.mylistid = '';
		umylist.makeUList();
	});
	$('#navFavU').on('click', function(){
		umylist.data.mylisttype = '';
		umylist.data.mylistid = '';
		umylist.makeUFavList();
	});
	$('#navMyList').on('click', function(){
		umylist.data.mylisttype = '';
		umylist.data.mylistid = '';
		umylist.makeMyListList();
	});
	$('#navNicoCache').on('click', function(){
		umylist.data.mylisttype = '';
		umylist.data.mylistid = '';
		umylist.makeNicoCacheListList();
	});
//	$('#navNewMyList').on('click', function(){
//		umylist.makeNewFavMyList();
//	});
});
})();
